<?php
define('DUAL_PRICE_VERSION', "1.0.1");

class ControllerModuleDualPrice extends Controller {

	public function index() {
		$this->load->language('module/dual_price');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		$settings = $this->model_setting_setting->getSetting('dual_price');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
			$this->model_setting_setting->editSetting('dual_price', $this->request->post);

			$this->session->data['success'] = $this->language->get('text_success');

			$this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
		}

		$data['heading_title'] = $this->language->get('heading_title');

		$data['text_edit'] = $this->language->get('text_edit');
		$data['text_extension'] = $this->language->get('text_extension');
		$data['text_enabled'] = $this->language->get('text_enabled');
		$data['text_disabled'] = $this->language->get('text_disabled');
		$data['entry_status'] = $this->language->get('entry_status');

		//PARTNERis add language
		$data['entry_source_language'] = $this->language->get('entry_source_language');
		$data['entry_quantity_status'] = $this->language->get('entry_quantity_status');
		//end PARTNERis

		$data['button_save'] = $this->language->get('button_save');
		$data['button_cancel'] = $this->language->get('button_cancel');

		$data['tab_general'] = $this->language->get('tab_general');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'] ,'SSL')
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('module/dual_price', 'token=' . $this->session->data['token'], 'SSL')
		);

		$data['action'] = $this->url->link('module/dual_price', 'token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'] . '&type=module', 'SSL');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$this->load->model('setting/store');

		$stores = $this->model_setting_store->getStores();

		$data['stores'][] = array(
			'name' => $this->config->get('config_name'),
			'store_id' => 0
		);

		$data['stores'] = array_merge($data['stores'], $stores);

		if (isset($this->request->post['dual_price_currency_id'])) {
			$data['dual_price_currency_id'] = $this->request->post['dual_price_currency_id'];
		} elseif (isset($settings['dual_price_currency_id']) || !isset($settings['dual_price_currency_id'])) {
			$data['dual_price_currency_id'] = array();
			foreach ($data['stores'] as $store) {
				$store_id = $store['store_id'];
				$curr_def = $this->db->query("SELECT value FROM " . DB_PREFIX . "setting WHERE store_id = '".$store_id."' AND `key` = 'config_currency'")->row['value'];
				$glfs = $this->db->query("SELECT * FROM " . DB_PREFIX . "currency WHERE code != '".$curr_def."'");

				foreach ($glfs->rows as $curr) {
					if (isset($settings['dual_price_currency_id'][$store_id]) && $settings['dual_price_currency_id'][$store_id] == $curr['currency_id']) {
						$data['dual_price_currency_id'][] = array (
							'store_id' => $store_id,
							'curr_id' => $curr['currency_id'],
							'set'	  => 1,
							'curr_title' => $curr['title'],
						);
					} else {
						$data['dual_price_currency_id'][] = array (
							'store_id' => $store_id,
							'curr_id' => $curr['currency_id'],
							'set'	  => 0,
							'curr_title' => $curr['title'],
						);
					}
				}
			}
		} else {

		}

		if (isset($this->request->post['dual_price_status'])) {
			$data['dual_price_status'] = $this->request->post['dual_price_status'];
		} else {
			$data['dual_price_status'] = $this->config->get('dual_price_status');
		}

		if (isset($this->request->post['dual_price_css'])) {
			$data['dual_price_css'] = $this->request->post['dual_price_css'];
		} else {
			$data['dual_price_css'] = $this->config->get('dual_price_css');
		}

		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/dual_price.tpl', $data));
	}

	protected function validate() {
		if (!$this->user->hasPermission('modify', 'extension/module/dual_price')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		return !$this->error;
	}
}
?>
