<?php

class ControllerModuleLabelimage extends Controller {

    private $error = array();

    public function index() {
        $this->language->load('module/labelimage');

        $this->load->model('setting/setting');

        $this->document->setTitle($this->language->get('heading_title'));

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('labelimage', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $data['heading_title'] = $this->language->get('heading_title');

        $data['entry_creator'] = $this->language->get('entry_creator');
        $data['entry_version'] = $this->language->get('entry_version');
        $data['entry_updated'] = $this->language->get('entry_updated');
        $data['entry_licence'] = $this->language->get('entry_licence');


        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        $data['entry_enable'] = $this->language->get('entry_enable');
        $data['entry_enable_desc'] = $this->language->get('entry_enable_desc');
        $data['entry_latest'] = $this->language->get('entry_latest');
        $data['entry_latest_desc'] = $this->language->get('entry_latest_desc');
        $data['entry_featured'] = $this->language->get('entry_featured');
        $data['entry_featured_desc'] = $this->language->get('entry_featured_desc');
		$data['entry_featuredcarousel'] = $this->language->get('entry_featured');
        $data['entry_featuredcarousel_desc'] = $this->language->get('entry_featured_desc');
        $data['entry_bestseller'] = $this->language->get('entry_bestseller');
        $data['entry_bestseller_desc'] = $this->language->get('entry_bestseller_desc');
        $data['entry_special'] = $this->language->get('entry_special');
        $data['entry_special_desc'] = $this->language->get('entry_special_desc');
        $data['entry_productpros'] = $this->language->get('entry_productpros');
        $data['entry_productpros_desc'] = $this->language->get('entry_productpros_desc');
        $data['entry_productexpros'] = $this->language->get('entry_productexpros');
        $data['entry_productexpros_desc'] = $this->language->get('entry_productexpros_desc');
        $data['entry_showonadmin'] = $this->language->get('entry_showonadmin');
        $data['entry_showonadmin_desc'] = $this->language->get('entry_showonadmin_desc');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');
        $data['text_yes'] = $this->language->get('text_yes');
        $data['text_no'] = $this->language->get('text_no');
        $data['entry_autoresize'] = $this->language->get('entry_autoresize');
        $data['entry_autoresize_desc'] = $this->language->get('entry_autoresize_desc');


        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['client_id'])) {
            $data['error_client_id'] = $this->error['client_id'];
        } else {
            $data['error_client_id'] = '';
        }

        if (isset($this->error['secret'])) {
            $data['error_secret'] = $this->error['secret'];
        } else {
            $data['error_secret'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_module'),
            'href' => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/labelimage', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $data['action'] = $this->url->link('module/labelimage', 'token=' . $this->session->data['token'], 'SSL');

        $data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

        $data['modules'] = array();

        if (isset($this->request->post['labelimage_status'])) {
            $data['labelimage_status'] = $this->request->post['labelimage_status'];
        } else {
            $data['labelimage_status'] = $this->config->get('labelimage_status');
        }

        if (isset($this->request->post['labelimage_latest'])) {
            $data['labelimage_latest'] = $this->request->post['labelimage_latest'];
        } elseif ($this->config->get('labelimage_latest')) {
            $data['labelimage_latest'] = $this->config->get('labelimage_latest');
        } else
            $data['labelimage_latest'] = '';

        if (isset($this->request->post['labelimage_featured'])) {
            $data['labelimage_featured'] = $this->request->post['labelimage_featured'];
        } elseif ($this->config->get('labelimage_featured')) {
            $data['labelimage_featured'] = $this->config->get('labelimage_featured');
        } else
            $data['labelimage_featured'] = '';
        if (isset($this->request->post['labelimage_featuredcarousel'])) {
            $data['labelimage_featuredcarousel'] = $this->request->post['labelimage_featuredcarousel'];
        } elseif ($this->config->get('labelimage_featuredcarousel')) {
            $data['labelimage_featuredcarousel'] = $this->config->get('labelimage_featuredcarousel');
        } else
            $data['labelimage_featuredcarousel'] = '';		

        if (isset($this->request->post['labelimage_bestseller'])) {
            $data['labelimage_bestseller'] = $this->request->post['labelimage_bestseller'];
        } elseif ($this->config->get('labelimage_bestseller')) {
            $data['labelimage_bestseller'] = $this->config->get('labelimage_bestseller');
        } else
            $data['labelimage_bestseller'] = '';

        if (isset($this->request->post['labelimage_special'])) {
            $data['labelimage_special'] = $this->request->post['labelimage_special'];
        } elseif ($this->config->get('labelimage_special')) {
            $data['labelimage_special'] = $this->config->get('labelimage_special');
        } else
            $data['labelimage_special'] = '';

        if (isset($this->request->post['labelimage_autoresize'])) {
            $data['labelimage_autoresize'] = $this->request->post['labelimage_autoresize'];
        } elseif ($this->config->get('labelimage_autoresize')) {
            $data['labelimage_autoresize'] = $this->config->get('labelimage_autoresize');
        } else
            $data['labelimage_autoresize'] = '';

        if (isset($this->request->post['labelimage_productpros'])) {
            $data['labelimage_productpros'] = $this->request->post['labelimage_productpros'];
        } elseif ($this->config->get('labelimage_productpros')) {
            $data['labelimage_productpros'] = $this->config->get('labelimage_productpros');
        } else
            $data['labelimage_productpros'] = '40';


        if (isset($this->request->post['labelimage_productexpros'])) {
            $data['labelimage_productexpros'] = $this->request->post['labelimage_productexpros'];
        } elseif ($this->config->get('labelimage_productexpros')) {
            $data['labelimage_productexpros'] = $this->config->get('labelimage_productexpros');
        } else
            $data['labelimage_productexpros'] = '40';

        if (isset($this->request->post['labelimage_showonadmin'])) {
            $data['labelimage_showonadmin'] = $this->request->post['labelimage_showonadmin'];
        } elseif ($this->config->get('labelimage_showonadmin')) {
            $data['labelimage_showonadmin'] = $this->config->get('labelimage_showonadmin');
        } else
            $data['labelimage_showonadmin'] = '';


        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('module/labelimage.tpl', $data));
    }

    private function validate() {
        if (!$this->user->hasPermission('modify', 'module/labelimage')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }


        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }

}

?>