<?php

class ModelToolLabelimage extends Model {

    function setLabelImage($filename = '', $topleft = '', $topright = '', $bottomleft = '', $bottomright = '', $http = '', $imagefield, $productid, $width, $height, $scale = 100, $autoresize = 1) {
        $orgfilename = $filename;
        $info = pathinfo($imagefield);
        $extension = $info['extension'];
        if (file_exists(DIR_IMAGE . substr($filename, strlen($http)))) {
            $filename = substr($filename, strlen($http));
        } else {
            return $filename;
        }
        if (empty($topleft) && empty($topright) && empty($bottomleft) && empty($bottomright))
            return $orgfilename;

        $info = pathinfo(DIR_IMAGE . $filename);
        $extension = $info['extension'];
        $original = new Image(DIR_IMAGE . $filename);
        if (!empty($topleft) && file_exists(DIR_IMAGE . $topleft)) {
            //list($w, $h) = getimagesize(DIR_IMAGE . $topleft);
            if ($autoresize == 1) {
                $image = $this->smart_resize_image(DIR_IMAGE . $topleft, $width * ($scale / 100), $height * ($scale / 100), true);
            } else
                $image = $this->smart_resize_image(DIR_IMAGE . $topleft, $width, $height, true);
            $this->imagecopymerge_alpha($original->image, $image, 0, 0, 0, 0, imagesx($image), imagesy($image), 100);
            imagesavealpha($original->image, true);
            unset($image);
        }
        if (!empty($topright) && file_exists(DIR_IMAGE . $topright)) {
            if ($autoresize == 1) {
                $image = $this->smart_resize_image(DIR_IMAGE . $topright, $width * ($scale / 100), $height * ($scale / 100), true);
            } else
                $image = $this->smart_resize_image(DIR_IMAGE . $topright, $width, $height, true);
            $this->imagecopymerge_alpha($original->image, $image, imagesx($original->image) - imagesx($image), 0, 0, 0, imagesx($image), imagesy($image), 100);
            imagesavealpha($original->image, true);
            unset($image);
        }

        if (!empty($bottomleft) && file_exists(DIR_IMAGE . $bottomleft)) {
            if ($autoresize == 1) {
                $image = $this->smart_resize_image(DIR_IMAGE . $bottomleft, $width * ($scale / 100), $height * ($scale / 100), true);
            } else
                $image = $this->smart_resize_image(DIR_IMAGE . $bottomleft, $width, $height, true);
            $this->imagecopymerge_alpha($original->image, $image, 0, imagesy($original->image) - imagesy($image), 0, 0, imagesx($image), imagesy($image), 100);
            imagesavealpha($original->image, true);
            unset($image);
        }
        if (!empty($bottomright) && file_exists(DIR_IMAGE . $bottomright)) {
            if ($autoresize == 1) {
                $image = $this->smart_resize_image(DIR_IMAGE . $bottomright, $width * ($scale / 100), $height * ($scale / 100), true);
            } else
                $image = $this->smart_resize_image(DIR_IMAGE . $bottomright, $width, $height, true);
            $this->imagecopymerge_alpha($original->image, $image, imagesx($original->image) - imagesx($image), imagesy($original->image) - imagesy($image), 0, 0, imagesx($image), imagesy($image), 100);
            imagesavealpha($original->image, true);
            unset($image);
        }

        if (!empty($productid))
            $newfilename = 'cache/' . dirname($imagefield) . '/' . $productid . '_' . '-' . $width . 'x' . $height . '.' . $extension;
        else
            $newfilename = 'cache/' . dirname($imagefield) . '/' . $filenameOnly . '_' . '-' . $width . 'x' . $height . '.' . $extension;
        $original->save(DIR_IMAGE . $newfilename);
        unset($original);
        return $http . $newfilename;
    }

    function imagecopymerge_alpha($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h, $pct) {
        if (!isset($pct)) {
            return false;
        }
        $pct /= 100;
        // Get image width and height
        $w = imagesx($src_im);
        $h = imagesy($src_im);
        // Turn alpha blending off
        imagealphablending($src_im, false);
        // Find the most opaque pixel in the image (the one with the smallest alpha value)
        $minalpha = 127;
        for ($x = 0; $x < $w; $x++)
            for ($y = 0; $y < $h; $y++) {
                $alpha = ( imagecolorat($src_im, $x, $y) >> 24 ) & 0xFF;
                if ($alpha < $minalpha) {
                    $minalpha = $alpha;
                }
            }
        //loop through image pixels and modify alpha for each
        for ($x = 0; $x < $w; $x++) {
            for ($y = 0; $y < $h; $y++) {
                //get current alpha value (represents the TANSPARENCY!)
                $colorxy = imagecolorat($src_im, $x, $y);
                $alpha = ( $colorxy >> 24 ) & 0xFF;
                //calculate new alpha
                if ($minalpha !== 127) {
                    $alpha = 127 + 127 * $pct * ( $alpha - 127 ) / ( 127 - $minalpha );
                } else {
                    $alpha += 127 * $pct;
                }
                //get the color index with new alpha
                $alphacolorxy = imagecolorallocatealpha($src_im, ( $colorxy >> 16 ) & 0xFF, ( $colorxy >> 8 ) & 0xFF, $colorxy & 0xFF, $alpha);
                //set pixel with the new color + opacity
                if (!imagesetpixel($src_im, $x, $y, $alphacolorxy)) {
                    return false;
                }
            }
        }

        // The image copy
        imagecopy($dst_im, $src_im, $dst_x, $dst_y, $src_x, $src_y, $src_w, $src_h);
    }

    function smart_resize_image($file, $width = 0, $height = 0, $proportional = false) {
        //return false;
        $trnprt_color['red'] = 255;
        $trnprt_color['green'] = 255;
        $trnprt_color['blue'] = 255;
        $trnprt_indx = 127;
        if ($height <= 0 && $width <= 0)
            return false;

        # Setting defaults and meta
        $info = getimagesize($file);
        $image = '';
        $final_width = 0;
        $final_height = 0;
        list($width_old, $height_old) = $info;

        # Calculating proportionality
        if ($proportional) {
            if ($width == 0)
                $factor = $height / $height_old;
            elseif ($height == 0)
                $factor = $width / $width_old;
            else
                $factor = min($width / $width_old, $height / $height_old);

            $final_width = round($width_old * $factor);
            $final_height = round($height_old * $factor);
        }
        else {
            $final_width = ( $width <= 0 ) ? $width_old : $width;
            $final_height = ( $height <= 0 ) ? $height_old : $height;
        }

        # Loading image to memory according to type
        switch ($info[2]) {
            case IMAGETYPE_GIF: $image = imagecreatefromgif($file);
                break;
            case IMAGETYPE_JPEG: $image = imagecreatefromjpeg($file);
                break;
            case IMAGETYPE_PNG: $image = imagecreatefrompng($file);
                break;
            default: return false;
        }


        # This is the resizing/resampling/transparency-preserving magic
        $image_resized = imagecreatetruecolor($final_width, $final_height);
        if (($info[2] == IMAGETYPE_GIF) || ($info[2] == IMAGETYPE_PNG)) {
            $transparency = imagecolortransparent($image);

            if ($transparency >= 0) {
                $transparent_color = imagecolorsforindex($image, $trnprt_indx);
                $transparency = imagecolorallocate($image_resized, $trnprt_color['red'], $trnprt_color['green'], $trnprt_color['blue']);
                imagefill($image_resized, 0, 0, $transparency);
                imagecolortransparent($image_resized, $transparency);
            } elseif ($info[2] == IMAGETYPE_PNG) {
                imagealphablending($image_resized, false);
                $color = imagecolorallocatealpha($image_resized, 0, 0, 0, 127);
                imagefill($image_resized, 0, 0, $color);
                imagesavealpha($image_resized, true);
            }
        }
        imagecopyresampled($image_resized, $image, 0, 0, 0, 0, $final_width, $final_height, $width_old, $height_old);

        return $image_resized;
    }

}

?>
