<?php
class ModelCatalogProduct extends Model {
	public function updateViewed($product_id) {
		$this->db->query("UPDATE " . DB_PREFIX . "product SET viewed = (viewed + 1) WHERE product_id = '" . (int)$product_id . "'");
	}

//START EXTRA PRODUCT TABS
		public function getTabs($product_id) {	
        $query = $this->db->query("SELECT tab_id, name, content FROM " . DB_PREFIX . "product_tabs WHERE product_id = '" . (int)$product_id . "' AND language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY sort_order ASC, name ASC");
        return $query->rows;
    	}
    	//START EXTRA PRODUCT TABS
	public function getProduct($product_id) {
		$query = $this->db->query("SELECT DISTINCT *, /*BUPS*/pd.name AS name, p.image, p.topleft_png, p.topright_png, p.bottomleft_png, p.bottomright_png,  m.name AS manufacturer, (SELECT price FROM " . DB_PREFIX . "product_discount pd2 WHERE pd2.product_id = p.product_id AND pd2.customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND pd2.quantity = '1' AND ((pd2.date_start = '0000-00-00' OR pd2.date_start < NOW()) AND (pd2.date_end = '0000-00-00' OR pd2.date_end > NOW())) ORDER BY pd2.priority ASC, pd2.price ASC LIMIT 1) AS discount, (SELECT price FROM " . DB_PREFIX . "product_special ps WHERE ps.product_id = p.product_id AND ps.customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) ORDER BY ps.priority ASC, ps.price ASC LIMIT 1) AS special, (SELECT points FROM " . DB_PREFIX . "product_reward pr WHERE pr.product_id = p.product_id AND customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "') AS reward, (SELECT ss.name FROM " . DB_PREFIX . "stock_status ss WHERE ss.stock_status_id = p.stock_status_id AND ss.language_id = '" . (int)$this->config->get('config_language_id') . "') AS stock_status, (SELECT wcd.unit FROM " . DB_PREFIX . "weight_class_description wcd WHERE p.weight_class_id = wcd.weight_class_id AND wcd.language_id = '" . (int)$this->config->get('config_language_id') . "') AS weight_class, (SELECT lcd.unit FROM " . DB_PREFIX . "length_class_description lcd WHERE p.length_class_id = lcd.length_class_id AND lcd.language_id = '" . (int)$this->config->get('config_language_id') . "') AS length_class, (SELECT AVG(rating) AS total FROM " . DB_PREFIX . "review r1 WHERE r1.product_id = p.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating, (SELECT COUNT(*) AS total FROM " . DB_PREFIX . "review r2 WHERE r2.product_id = p.product_id AND r2.status = '1' GROUP BY r2.product_id) AS reviews, p.sort_order FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) LEFT JOIN " . DB_PREFIX . "manufacturer m ON (p.manufacturer_id = m.manufacturer_id) WHERE p.product_id = '" . (int)$product_id . "' AND pd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "'");

		if ($query->num_rows) {
			return array(
				'product_id'       => $query->row['product_id'],
				'name'             => $query->row['name'],
				'description'      => $query->row['description'],
				'meta_title'       => $query->row['meta_title'],
				'meta_description' => $query->row['meta_description'],
				'meta_keyword'     => $query->row['meta_keyword'],
				'tag'              => $query->row['tag'],
				'model'            => $query->row['model'],
				'sku'              => $query->row['sku'],
				'upc'              => $query->row['upc'],
				'ean'              => $query->row['ean'],
				'jan'              => $query->row['jan'],
				'isbn'             => $query->row['isbn'],
				'mpn'              => $query->row['mpn'],
				'location'         => $query->row['location'],
				'quantity'         => $query->row['quantity'],
				'stock_status'     => $query->row['stock_status'],
				'image'            => $query->row['image'],
				'manufacturer_id'  => $query->row['manufacturer_id'],
				'manufacturer'     => $query->row['manufacturer'],
				'price'            => ($query->row['discount'] ? $query->row['discount'] : $query->row['price']),
				'special'          => $query->row['special'],
				'reward'           => $query->row['reward'],
				'points'           => $query->row['points'],
				'tax_class_id'     => $query->row['tax_class_id'],
				'date_available'   => $query->row['date_available'],
				'weight'           => $query->row['weight'],
				'weight_class_id'  => $query->row['weight_class_id'],
				'length'           => $query->row['length'],
				'width'            => $query->row['width'],
				'height'           => $query->row['height'],
				'length_class_id'  => $query->row['length_class_id'],
				'subtract'         => $query->row['subtract'],
				'rating'           => round($query->row['rating']),
				'reviews'          => $query->row['reviews'] ? $query->row['reviews'] : 0,
				'minimum'          => $query->row['minimum'],
				'sort_order'       => $query->row['sort_order'],
				'status'           => $query->row['status'],
				'date_added'       => $query->row['date_added'],
				'date_modified'    => $query->row['date_modified'],
				'viewed'           => $query->row['viewed']
//BUPS
                                ,'topleft_png'           => isset($query->row['topleft_png'])?$query->row['topleft_png']:null,
				'topright_png'       => isset($query->row['topright_png'])?$query->row['topright_png']:null,
				'bottomleft_png'    => isset($query->row['bottomleft_png'])?$query->row['bottomleft_png']:null,
				'bottomright_png'           => isset($query->row['bottomright_png'])?$query->row['bottomright_png']:null
                                //end

			);
		} else {
			return false;
		}
	}

	public function getProducts($data = array()) {
		$sql = "SELECT p.product_id, (SELECT AVG(rating) AS total FROM " . DB_PREFIX . "review r1 WHERE r1.product_id = p.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating, (SELECT price FROM " . DB_PREFIX . "product_discount pd2 WHERE pd2.product_id = p.product_id AND pd2.customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND pd2.quantity = '1' AND ((pd2.date_start = '0000-00-00' OR pd2.date_start < NOW()) AND (pd2.date_end = '0000-00-00' OR pd2.date_end > NOW())) ORDER BY pd2.priority ASC, pd2.price ASC LIMIT 1) AS discount, (SELECT price FROM " . DB_PREFIX . "product_special ps WHERE ps.product_id = p.product_id AND ps.customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) ORDER BY ps.priority ASC, ps.price ASC LIMIT 1) AS special";

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " FROM " . DB_PREFIX . "category_path cp LEFT JOIN " . DB_PREFIX . "product_to_category p2c ON (cp.category_id = p2c.category_id)";
			} else {
				$sql .= " FROM " . DB_PREFIX . "product_to_category p2c";
			}

			if (!empty($data['filter_filter'])) {
				$sql .= " LEFT JOIN " . DB_PREFIX . "product_filter pf ON (p2c.product_id = pf.product_id) LEFT JOIN " . DB_PREFIX . "product p ON (pf.product_id = p.product_id)";
			} else {
				$sql .= " LEFT JOIN " . DB_PREFIX . "product p ON (p2c.product_id = p.product_id)";
			}
		} else {
			$sql .= " FROM " . DB_PREFIX . "product p";
		}

		$sql .= " LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "'";

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " AND cp.path_id = '" . (int)$data['filter_category_id'] . "'";
			} else {
				
			$cat_sql = "SELECT `category_id` FROM `" . DB_PREFIX . "category_path` WHERE `path_id` = '" . (int)$data['filter_category_id'] . "'";
			$cat_query = $this->db->query($cat_sql);
			if ($cat_query->num_rows) {
				$sql .= " AND (p2c.category_id = '" . (int)$data['filter_category_id'] . "'";
				foreach($cat_query->rows as $cat) {
					$sql .= " OR p2c.category_id = '" . (int)$cat['category_id'] . "'";
				}
				$sql .= ")";
			}
			else {
				$sql .= " AND p2c.category_id = '" . (int)$data['filter_category_id'] . "'";
			}
			
			}

			if (!empty($data['filter_filter'])) {
				$implode = array();

				$filters = explode(',', $data['filter_filter']);

				foreach ($filters as $filter_id) {
					$implode[] = (int)$filter_id;
				}

				$sql .= " AND pf.filter_id IN (" . implode(',', $implode) . ")";
			}
		}

		if (!empty($data['filter_name']) || !empty($data['filter_tag'])) {
			$sql .= " AND (";

			if (!empty($data['filter_name'])) {
				$implode = array();

				$words = explode(' ', trim(preg_replace('/\s+/', ' ', $data['filter_name'])));

				foreach ($words as $word) {
					$implode[] = "pd.name LIKE '%" . $this->db->escape($word) . "%'";
				}

				if ($implode) {
					$sql .= " " . implode(" AND ", $implode) . "";
				}

				if (!empty($data['filter_description'])) {
					$sql .= " OR pd.description LIKE '%" . $this->db->escape($data['filter_name']) . "%'";
				}
			}

			if (!empty($data['filter_name']) && !empty($data['filter_tag'])) {
				$sql .= " OR ";
			}

			if (!empty($data['filter_tag'])) {
				$sql .= "pd.tag LIKE '%" . $this->db->escape($data['filter_tag']) . "%'";
			}

			if (!empty($data['filter_name'])) {
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_model')) > 0) {
				$sql .= " OR LCASE(p.model) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.model) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_sku')) > 0) {
				$sql .= " OR LCASE(p.sku) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.sku) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_upc')) > 0) {
				$sql .= " OR LCASE(p.upc) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.upc) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_ean')) > 0) {
				$sql .= " OR LCASE(p.ean) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.ean) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_jan')) > 0) {
				$sql .= " OR LCASE(p.jan) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.jan) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_isbn')) > 0) {
				$sql .= " OR LCASE(p.isbn) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.isbn) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_mpn')) > 0) {
				$sql .= " OR LCASE(p.mpn) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.mpn) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END

// ExtendedSearch
			if ((!empty($data['filter_name'])) && ($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_location')) > 0) {
				$sql .= " OR LCASE(p.location) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				}

			if ((!empty($data['filter_name'])) && ($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_attr')) > 0) {
				$sql .= " OR p.product_id IN (SELECT pa.product_id FROM " . DB_PREFIX . "product_attribute pa WHERE pa.language_id = '" . (int)$this->config->get('config_language_id') . "' AND LCASE(pa.text) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%' ) ";
				}
// ExtendedSearch END
			
			
			}

			$sql .= ")";
		}

		if (!empty($data['filter_manufacturer_id'])) {
			$sql .= " AND p.manufacturer_id = '" . (int)$data['filter_manufacturer_id'] . "'";
		}

		$sql .= " GROUP BY p.product_id";

		$sort_data = array(
			'pd.name',
			'p.model',
			'p.quantity',
			'p.price',
			'rating',
			'p.sort_order',
			'p.date_added'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			if ($data['sort'] == 'pd.name' || $data['sort'] == 'p.model') {
				$sql .= " ORDER BY LCASE(" . $data['sort'] . ")";
			} elseif ($data['sort'] == 'p.price') {
				$sql .= " ORDER BY (CASE WHEN special IS NOT NULL THEN special WHEN discount IS NOT NULL THEN discount ELSE p.price END)";
			} else {
				$sql .= " ORDER BY " . $data['sort'];
			}
		} else {
			$sql .= " ORDER BY p.sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC, LCASE(pd.name) DESC";
		} else {
			$sql .= " ASC, LCASE(pd.name) ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$product_data = array();

		$query = $this->db->query($sql);

		foreach ($query->rows as $result) {
			$product_data[$result['product_id']] = $this->getProduct($result['product_id']);
		}

		return $product_data;
	}

	public function getProductSpecials($data = array()) {
		$sql = "SELECT DISTINCT ps.product_id, (SELECT AVG(rating) FROM " . DB_PREFIX . "review r1 WHERE r1.product_id = ps.product_id AND r1.status = '1' GROUP BY r1.product_id) AS rating FROM " . DB_PREFIX . "product_special ps LEFT JOIN " . DB_PREFIX . "product p ON (ps.product_id = p.product_id) LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "' AND ps.customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW())) GROUP BY ps.product_id";

		$sort_data = array(
			'pd.name',
			'p.model',
			'ps.price',
			'rating',
			'p.sort_order'
		);

		if (isset($data['sort']) && in_array($data['sort'], $sort_data)) {
			if ($data['sort'] == 'pd.name' || $data['sort'] == 'p.model') {
				$sql .= " ORDER BY LCASE(" . $data['sort'] . ")";
			} else {
				$sql .= " ORDER BY " . $data['sort'];
			}
		} else {
			$sql .= " ORDER BY p.sort_order";
		}

		if (isset($data['order']) && ($data['order'] == 'DESC')) {
			$sql .= " DESC, LCASE(pd.name) DESC";
		} else {
			$sql .= " ASC, LCASE(pd.name) ASC";
		}

		if (isset($data['start']) || isset($data['limit'])) {
			if ($data['start'] < 0) {
				$data['start'] = 0;
			}

			if ($data['limit'] < 1) {
				$data['limit'] = 20;
			}

			$sql .= " LIMIT " . (int)$data['start'] . "," . (int)$data['limit'];
		}

		$product_data = array();

		$query = $this->db->query($sql);

		foreach ($query->rows as $result) {
			$product_data[$result['product_id']] = $this->getProduct($result['product_id']);
		}

		return $product_data;
	}

	public function getLatestProducts($limit) {
		$product_data = $this->cache->get('product.latest.' . (int)$this->config->get('config_language_id') . '.' . (int)$this->config->get('config_store_id') . '.' . $this->config->get('config_customer_group_id') . '.' . (int)$limit);

		if (!$product_data) {
			$query = $this->db->query("SELECT p.product_id FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "' ORDER BY p.date_added DESC LIMIT " . (int)$limit);

			foreach ($query->rows as $result) {
				$product_data[$result['product_id']] = $this->getProduct($result['product_id']);
			}

			$this->cache->set('product.latest.' . (int)$this->config->get('config_language_id') . '.' . (int)$this->config->get('config_store_id') . '.' . $this->config->get('config_customer_group_id') . '.' . (int)$limit, $product_data);
		}

		return $product_data;
	}

	public function getPopularProducts($limit) {
		$product_data = array();

		$query = $this->db->query("SELECT p.product_id FROM " . DB_PREFIX . "product p LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "' ORDER BY p.viewed DESC, p.date_added DESC LIMIT " . (int)$limit);

		foreach ($query->rows as $result) {
			$product_data[$result['product_id']] = $this->getProduct($result['product_id']);
		}

		return $product_data;
	}

	public function getBestSellerProducts($limit) {
		$product_data = $this->cache->get('product.bestseller.' . (int)$this->config->get('config_language_id') . '.' . (int)$this->config->get('config_store_id') . '.' . $this->config->get('config_customer_group_id') . '.' . (int)$limit);

		if (!$product_data) {
			$product_data = array();

			$query = $this->db->query("SELECT op.product_id, SUM(op.quantity) AS total FROM " . DB_PREFIX . "order_product op LEFT JOIN `" . DB_PREFIX . "order` o ON (op.order_id = o.order_id) LEFT JOIN `" . DB_PREFIX . "product` p ON (op.product_id = p.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE o.order_status_id > '0' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "' GROUP BY op.product_id ORDER BY total DESC LIMIT " . (int)$limit);

			foreach ($query->rows as $result) {
				$product_data[$result['product_id']] = $this->getProduct($result['product_id']);
			}

			$this->cache->set('product.bestseller.' . (int)$this->config->get('config_language_id') . '.' . (int)$this->config->get('config_store_id') . '.' . $this->config->get('config_customer_group_id') . '.' . (int)$limit, $product_data);
		}

		return $product_data;
	}

	public function getProductAttributes($product_id) {
		$product_attribute_group_data = array();

		$product_attribute_group_query = $this->db->query("SELECT ag.attribute_group_id, agd.name FROM " . DB_PREFIX . "product_attribute pa LEFT JOIN " . DB_PREFIX . "attribute a ON (pa.attribute_id = a.attribute_id) LEFT JOIN " . DB_PREFIX . "attribute_group ag ON (a.attribute_group_id = ag.attribute_group_id) LEFT JOIN " . DB_PREFIX . "attribute_group_description agd ON (ag.attribute_group_id = agd.attribute_group_id) WHERE pa.product_id = '" . (int)$product_id . "' AND agd.language_id = '" . (int)$this->config->get('config_language_id') . "' GROUP BY ag.attribute_group_id ORDER BY ag.sort_order, agd.name");

		foreach ($product_attribute_group_query->rows as $product_attribute_group) {
			$product_attribute_data = array();

			$product_attribute_query = $this->db->query("SELECT a.attribute_id, ad.name, pa.text FROM " . DB_PREFIX . "product_attribute pa LEFT JOIN " . DB_PREFIX . "attribute a ON (pa.attribute_id = a.attribute_id) LEFT JOIN " . DB_PREFIX . "attribute_description ad ON (a.attribute_id = ad.attribute_id) WHERE pa.product_id = '" . (int)$product_id . "' AND a.attribute_group_id = '" . (int)$product_attribute_group['attribute_group_id'] . "' AND ad.language_id = '" . (int)$this->config->get('config_language_id') . "' AND pa.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY a.sort_order, ad.name");

			foreach ($product_attribute_query->rows as $product_attribute) {

		$product_attribute['text'] = html_entity_decode($product_attribute['text'], ENT_QUOTES, 'UTF-8');
		
				$product_attribute_data[] = array(
					'attribute_id' => $product_attribute['attribute_id'],
					'name'         => $product_attribute['name'],
					'text'         => $product_attribute['text']
				);
			}

			$product_attribute_group_data[] = array(
				'attribute_group_id' => $product_attribute_group['attribute_group_id'],
				'name'               => $product_attribute_group['name'],
				'attribute'          => $product_attribute_data
			);
		}

		return $product_attribute_group_data;
	}

	public function getProductOptions($product_id) {
		$product_option_data = array();

		$product_option_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_option po LEFT JOIN `" . DB_PREFIX . "option` o ON (po.option_id = o.option_id) LEFT JOIN " . DB_PREFIX . "option_description od ON (o.option_id = od.option_id) WHERE po.product_id = '" . (int)$product_id . "' AND od.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY o.sort_order");

		foreach ($product_option_query->rows as $product_option) {
			$product_option_value_data = array();

			$product_option_value_query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_option_value pov LEFT JOIN " . DB_PREFIX . "option_value ov ON (pov.option_value_id = ov.option_value_id) LEFT JOIN " . DB_PREFIX . "option_value_description ovd ON (ov.option_value_id = ovd.option_value_id) WHERE pov.product_id = '" . (int)$product_id . "' AND pov.product_option_id = '" . (int)$product_option['product_option_id'] . "' AND ovd.language_id = '" . (int)$this->config->get('config_language_id') . "' ORDER BY ov.sort_order");

			foreach ($product_option_value_query->rows as $product_option_value) {
				$product_option_value_data[] = array(
					'product_option_value_id' => $product_option_value['product_option_value_id'],
					'option_value_id'         => $product_option_value['option_value_id'],
					'name'                    => $product_option_value['name'],
					'image'                   => $product_option_value['image'],
					'quantity'                => $product_option_value['quantity'],
					'subtract'                => $product_option_value['subtract'],
					'price'                   => $product_option_value['price'],
					'price_prefix'            => $product_option_value['price_prefix'],
					'weight'                  => $product_option_value['weight'],
					'weight_prefix'           => $product_option_value['weight_prefix']
				);
			}

			$product_option_data[] = array(
				'product_option_id'    => $product_option['product_option_id'],
				'product_option_value' => $product_option_value_data,
				'option_id'            => $product_option['option_id'],
				'name'                 => $product_option['name'],
				'type'                 => $product_option['type'],
				'value'                => $product_option['value'],
				'required'             => $product_option['required']
			);
		}

		return $product_option_data;
	}

	public function getProductDiscounts($product_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_discount WHERE product_id = '" . (int)$product_id . "' AND customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND quantity > 1 AND ((date_start = '0000-00-00' OR date_start < NOW()) AND (date_end = '0000-00-00' OR date_end > NOW())) ORDER BY quantity ASC, priority ASC, price ASC");

		return $query->rows;
	}

	public function getProductImages($product_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_image WHERE product_id = '" . (int)$product_id . "' ORDER BY sort_order ASC");

		return $query->rows;
	}

	public function getProductRelated($product_id) {
		$product_data = array();

		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_related pr LEFT JOIN " . DB_PREFIX . "product p ON (pr.related_id = p.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE pr.product_id = '" . (int)$product_id . "' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "'");

		foreach ($query->rows as $result) {
			$product_data[$result['related_id']] = $this->getProduct($result['related_id']);
		}

		return $product_data;
	}

	public function getProductLayoutId($product_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_to_layout WHERE product_id = '" . (int)$product_id . "' AND store_id = '" . (int)$this->config->get('config_store_id') . "'");

		if ($query->num_rows) {
			return $query->row['layout_id'];
		} else {
			return 0;
		}
	}

	public function getCategories($product_id) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "product_to_category WHERE product_id = '" . (int)$product_id . "'");

		return $query->rows;
	}

	public function getTotalProducts($data = array()) {
		$sql = "SELECT COUNT(DISTINCT p.product_id) AS total";

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " FROM " . DB_PREFIX . "category_path cp LEFT JOIN " . DB_PREFIX . "product_to_category p2c ON (cp.category_id = p2c.category_id)";
			} else {
				$sql .= " FROM " . DB_PREFIX . "product_to_category p2c";
			}

			if (!empty($data['filter_filter'])) {
				$sql .= " LEFT JOIN " . DB_PREFIX . "product_filter pf ON (p2c.product_id = pf.product_id) LEFT JOIN " . DB_PREFIX . "product p ON (pf.product_id = p.product_id)";
			} else {
				$sql .= " LEFT JOIN " . DB_PREFIX . "product p ON (p2c.product_id = p.product_id)";
			}
		} else {
			$sql .= " FROM " . DB_PREFIX . "product p";
		}

		$sql .= " LEFT JOIN " . DB_PREFIX . "product_description pd ON (p.product_id = pd.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE pd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "'";

		if (!empty($data['filter_category_id'])) {
			if (!empty($data['filter_sub_category'])) {
				$sql .= " AND cp.path_id = '" . (int)$data['filter_category_id'] . "'";
			} else {
				
			$cat_sql = "SELECT `category_id` FROM `" . DB_PREFIX . "category_path` WHERE `path_id` = '" . (int)$data['filter_category_id'] . "'";
			$cat_query = $this->db->query($cat_sql);
			if ($cat_query->num_rows) {
				$sql .= " AND (p2c.category_id = '" . (int)$data['filter_category_id'] . "'";
				foreach($cat_query->rows as $cat) {
					$sql .= " OR p2c.category_id = '" . (int)$cat['category_id'] . "'";
				}
				$sql .= ")";
			}
			else {
				$sql .= " AND p2c.category_id = '" . (int)$data['filter_category_id'] . "'";
			}
			
			}

			if (!empty($data['filter_filter'])) {
				$implode = array();

				$filters = explode(',', $data['filter_filter']);

				foreach ($filters as $filter_id) {
					$implode[] = (int)$filter_id;
				}

				$sql .= " AND pf.filter_id IN (" . implode(',', $implode) . ")";
			}
		}

		if (!empty($data['filter_name']) || !empty($data['filter_tag'])) {
			$sql .= " AND (";

			if (!empty($data['filter_name'])) {
				$implode = array();

				$words = explode(' ', trim(preg_replace('/\s+/', ' ', $data['filter_name'])));

				foreach ($words as $word) {
					$implode[] = "pd.name LIKE '%" . $this->db->escape($word) . "%'";
				}

				if ($implode) {
					$sql .= " " . implode(" AND ", $implode) . "";
				}

				if (!empty($data['filter_description'])) {
					$sql .= " OR pd.description LIKE '%" . $this->db->escape($data['filter_name']) . "%'";
				}
			}

			if (!empty($data['filter_name']) && !empty($data['filter_tag'])) {
				$sql .= " OR ";
			}

			if (!empty($data['filter_tag'])) {
				$sql .= "pd.tag LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_tag'])) . "%'";
			}

			if (!empty($data['filter_name'])) {
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_model')) > 0) {
				$sql .= " OR LCASE(p.model) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.model) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_sku')) > 0) {
				$sql .= " OR LCASE(p.sku) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.sku) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_upc')) > 0) {
				$sql .= " OR LCASE(p.upc) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.upc) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_ean')) > 0) {
				$sql .= " OR LCASE(p.ean) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.ean) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_jan')) > 0) {
				$sql .= " OR LCASE(p.jan) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.jan) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_isbn')) > 0) {
				$sql .= " OR LCASE(p.isbn) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.isbn) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END
			
				
// ExtendedSearch
			if (($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_mpn')) > 0) {
				$sql .= " OR LCASE(p.mpn) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				} else {
				$sql .= " OR LCASE(p.mpn) = '" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "'";
				}
// ExtendedSearch END

// ExtendedSearch
			if ((!empty($data['filter_name'])) && ($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_location')) > 0) {
				$sql .= " OR LCASE(p.location) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%'";
				}

			if ((!empty($data['filter_name'])) && ($this->config->get('extendedsearch_status')) > 0 && ($this->config->get('extendedsearch_attr')) > 0) {
				$sql .= " OR p.product_id IN (SELECT pa.product_id FROM " . DB_PREFIX . "product_attribute pa WHERE pa.language_id = '" . (int)$this->config->get('config_language_id') . "' AND LCASE(pa.text) LIKE '%" . $this->db->escape(utf8_strtolower($data['filter_name'])) . "%' ) ";
				}
// ExtendedSearch END
			
			
			}

			$sql .= ")";
		}

		if (!empty($data['filter_manufacturer_id'])) {
			$sql .= " AND p.manufacturer_id = '" . (int)$data['filter_manufacturer_id'] . "'";
		}

		$query = $this->db->query($sql);

		return $query->row['total'];
	}

	public function getProfile($product_id, $recurring_id) {
		return $this->db->query("SELECT * FROM `" . DB_PREFIX . "recurring` `p` JOIN `" . DB_PREFIX . "product_recurring` `pp` ON `pp`.`recurring_id` = `p`.`recurring_id` AND `pp`.`product_id` = " . (int)$product_id . " WHERE `pp`.`recurring_id` = " . (int)$recurring_id . " AND `status` = 1 AND `pp`.`customer_group_id` = " . (int)$this->config->get('config_customer_group_id'))->row;
	}

	public function getProfiles($product_id) {
		return $this->db->query("SELECT `pd`.* FROM `" . DB_PREFIX . "product_recurring` `pp` JOIN `" . DB_PREFIX . "recurring_description` `pd` ON `pd`.`language_id` = " . (int)$this->config->get('config_language_id') . " AND `pd`.`recurring_id` = `pp`.`recurring_id` JOIN `" . DB_PREFIX . "recurring` `p` ON `p`.`recurring_id` = `pd`.`recurring_id` WHERE `product_id` = " . (int)$product_id . " AND `status` = 1 AND `customer_group_id` = " . (int)$this->config->get('config_customer_group_id') . " ORDER BY `sort_order` ASC")->rows;
	}

public function getCustomeremailid($customer_id){
		$query = $this->db->query("SELECT email FROM " . DB_PREFIX . "customer where customer_id= '" . $customer_id . "'");
			if($query->row){
				return $query->row['email'];
			} else {
				return '';
			}
	}

	public function insertlowPricenotify($data){
		$query = $this->db->query("SELECT name FROM " . DB_PREFIX . "product_description where product_id= '" . (int)$data['product_id'] . "'");
		$productname = $query->row['name'];

		$checkexistemailandcustomer = $this->db->query("SELECT lowpricenotify_id FROM " . DB_PREFIX . "lowpricenotify where customer_id= '" . $data['customer_id'] . "' and customer_email= '" . $data['emailid'] . "'and product_id= '" . $data['product_id'] . "'");

		if(isset($checkexistemailandcustomer->row['lowpricenotify_id']) && !empty($checkexistemailandcustomer->row['lowpricenotify_id'])){
			$this->db->query("UPDATE " . DB_PREFIX . "lowpricenotify SET customer_id = '" . $this->db->escape($data['customer_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_name = '" . $this->db->escape($productname) . "',customer_email = '" . $this->db->escape($data['emailid']) . "',lowofferprice = '" . $this->db->escape($data['offerprice']) . "',notify_status = 0,date_added=NOW() WHERE customer_id = '" . $data['customer_id'] . "' and product_id = '" . (int)$data['product_id'] . "' and customer_email = '" . $data['emailid'] . "'");
			$this->db->query("DELETE FROM " . DB_PREFIX . "lowpricenotify_option_product WHERE lowpricenotify_id = '" . (int)$checkexistemailandcustomer->row['lowpricenotify_id'] . "'");
				if($data['select']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify_option_product` SET lowpricenotify_id = '" . $this->db->escape($checkexistemailandcustomer->row['lowpricenotify_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['select']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
				if($data['radio']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify_option_product` SET lowpricenotify_id = '" . $this->db->escape($checkexistemailandcustomer->row['lowpricenotify_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['radio']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
				if($data['checkbox']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify_option_product` SET lowpricenotify_id = '" . $this->db->escape($checkexistemailandcustomer->row['lowpricenotify_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['checkbox']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
			} else {

			$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify` SET customer_id = '" . $this->db->escape($data['customer_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_name = '" . $this->db->escape($productname) . "',customer_email = '" . $this->db->escape($data['emailid']) . "',lowofferprice = '" . $this->db->escape($data['offerprice']) . "',notify_status = 0,date_added=NOW()");

			$lowpricenotify_id = $this->db->getLastId();

			if($data['select']) {
				$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify_option_product` SET lowpricenotify_id = '" . $this->db->escape($lowpricenotify_id) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['select']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
			}
			if($data['radio']) {
				$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify_option_product` SET lowpricenotify_id = '" . $this->db->escape($lowpricenotify_id) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['radio']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
			}
			if($data['checkbox']) {
				$this->db->query("INSERT INTO `" . DB_PREFIX . "lowpricenotify_option_product` SET lowpricenotify_id = '" . $this->db->escape($lowpricenotify_id) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['checkbox']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
			}
		}
		//mail content
		$html = $this->language->get('dear')." ".$data['emailid'].",";
		$html .= "<br /><br />";
		//$html .= "Thank you for requesting. Once price drops for ".$productname.", we will update you by mail ";
		$get_lowofferprice_user_subs_mcon = $this->db->query("SELECT lowofferprice_user_subs_mcon FROM " . DB_PREFIX . "lowpricenotify_multilanguage where language_id= '" . (int)$this->config->get('config_language_id') . "'");
		if($get_lowofferprice_user_subs_mcon->row){
			$lowofferprice_user_subs_mcon =  $get_lowofferprice_user_subs_mcon->row['lowofferprice_user_subs_mcon'];
		} else {
			$lowofferprice_user_subs_mcon = false;
		}

		$html .= str_replace('{productname}',$productname, $lowofferprice_user_subs_mcon);

		$text ='';
		$subject = "";
		//$subject .= "Low price Notify from  " . $this->config->get('config_name');
			$get_lowofferprice_msub = $this->db->query("SELECT lowofferprice_msub FROM " . DB_PREFIX . "lowpricenotify_multilanguage where language_id= '" . (int)$this->config->get('config_language_id') . "'");
			if($get_lowofferprice_msub->row){
				$lowofferprice_msub =  $get_lowofferprice_msub->row['lowofferprice_msub'];
			} else {
				$lowofferprice_msub = false;
			}

		$subject .= str_replace('{store_name}', $this->config->get('config_name'), $lowofferprice_msub);

		$mail = new Mail();
		$mail->protocol = $this->config->get('config_mail_protocol');
		$mail->parameter = $this->config->get('config_mail_parameter');
		$mail->smtp_hostname = $this->config->get('config_mail_smtp_hostname');
		$mail->smtp_username = $this->config->get('config_mail_smtp_username');
		$mail->smtp_password = html_entity_decode($this->config->get('config_mail_smtp_password'), ENT_QUOTES, 'UTF-8');
		$mail->smtp_port = $this->config->get('config_mail_smtp_port');
		$mail->smtp_timeout = $this->config->get('config_mail_smtp_timeout');

		$mail->setTo($data['emailid']);
		$mail->setFrom($this->config->get('config_email'));
		$mail->setSender(html_entity_decode($this->config->get('config_name'), ENT_QUOTES, 'UTF-8'));
		$mail->setSubject(html_entity_decode($subject, ENT_QUOTES, 'UTF-8'));
		$mail->setHtml($html);
		$mail->setText($text);
		$mail->send();
		return 0;
	}

	public function addNotifymeEmail($data){
		$query = $this->db->query("SELECT name FROM " . DB_PREFIX . "product_description where product_id= '" . (int)$data['product_id'] . "'");
		$productname = $query->row['name'];

		$checkemailidexisting = $this->db->query("SELECT outofstocknotify_id FROM " . DB_PREFIX . "notifymeemail where emailid = '" . $this->db->escape($data['email']) . "' and  customer_id = '" . $this->db->escape($data['customer_id']) . "' and product_id = '" . $this->db->escape($data['product_id']) . "'");

			if(isset($checkemailidexisting->row['outofstocknotify_id']) && !empty($checkemailidexisting->row['outofstocknotify_id'])){
				$query = $this->db->query("UPDATE " . DB_PREFIX . "notifymeemail SET product_id = '" . $this->db->escape($data['product_id']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "',emailid = '" . $this->db->escape($data['email']) . "',product_id = '" . $this->db->escape($productname) . "',notify_status = 0,date_added = NOW() where emailid = '" . $this->db->escape($data['email']) . "' and  customer_id = '" . $this->db->escape($data['customer_id']) . "' and product_name = '" . $this->db->escape($data['product_id']) . "' ");
				$this->db->query("DELETE FROM " . DB_PREFIX . "notifymeemail_option_product WHERE outofstocknotify_id = '" . (int)$checkemailidexisting->row['outofstocknotify_id'] . "'");
				if($data['select']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "notifymeemail_option_product` SET outofstocknotify_id = '" . $this->db->escape($checkemailidexisting->row['outofstocknotify_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['select']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
				if($data['radio']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "notifymeemail_option_product` SET outofstocknotify_id = '" . $this->db->escape($checkemailidexisting->row['outofstocknotify_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['radio']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
				if($data['checkbox']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "notifymeemail_option_product` SET outofstocknotify_id = '" . $this->db->escape($checkemailidexisting->row['outofstocknotify_id']) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['checkbox']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
			} else {

				$query = $this->db->query("INSERT INTO " . DB_PREFIX . "notifymeemail SET product_id = '" . $this->db->escape($data['product_id']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "',emailid = '" . $this->db->escape($data['email']) . "',product_name = '" . $this->db->escape($productname) . "',notify_status = 0,date_added = NOW()");

				$outofstocknotify_id = $this->db->getLastId();

				if($data['select']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "notifymeemail_option_product` SET outofstocknotify_id = '" . $this->db->escape($outofstocknotify_id) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['select']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
				if($data['radio']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "notifymeemail_option_product` SET outofstocknotify_id = '" . $this->db->escape($outofstocknotify_id) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['radio']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
				if($data['checkbox']) {
					$this->db->query("INSERT INTO `" . DB_PREFIX . "notifymeemail_option_product` SET outofstocknotify_id = '" . $this->db->escape($outofstocknotify_id) . "',product_id = '" . $this->db->escape($data['product_id']) . "',product_option_value_id = '" . $this->db->escape($data['checkbox']) . "',customer_id = '" . $this->db->escape($data['customer_id']) . "'");
				}
			}
		return 1;
	}
	//multi language start
	public function getLowpricenotifyText(){
		$query = $this->db->query("SELECT show_lowpricenotify_text_name FROM " . DB_PREFIX . "lowpricenotify_multilanguage where language_id= '" . (int)$this->config->get('config_language_id') . "'");
		if($query->row){
			return $query->row['show_lowpricenotify_text_name'];
		} else {
			return false;
		}
	}
	//multi language end
	public function getTotalProductSpecials() {
		$query = $this->db->query("SELECT COUNT(DISTINCT ps.product_id) AS total FROM " . DB_PREFIX . "product_special ps LEFT JOIN " . DB_PREFIX . "product p ON (ps.product_id = p.product_id) LEFT JOIN " . DB_PREFIX . "product_to_store p2s ON (p.product_id = p2s.product_id) WHERE p.status = '1' AND p.date_available <= NOW() AND p2s.store_id = '" . (int)$this->config->get('config_store_id') . "' AND ps.customer_group_id = '" . (int)$this->config->get('config_customer_group_id') . "' AND ((ps.date_start = '0000-00-00' OR ps.date_start < NOW()) AND (ps.date_end = '0000-00-00' OR ps.date_end > NOW()))");

		if (isset($query->row['total'])) {
			return $query->row['total'];
		} else {
			return 0;
		}
	}
}
