<?php
class ControllerCommonMaintenance extends Controller {
	public function index() {

                if ($this->config->get('config_template') == 'default2') {
                    $this->load->model('setting/setting');

                    // Fallback setting
                    $default_preset = array(
                        'store_id'                      => 0,
                        'preset_id'                     => 0,
                        'preset_name'                   => '',

                        // Styling
                        'font_header'                   => 'verdana',
                        'font_base'                     => 'arial',
                        'font_size'                     => '14px',
                        'font_color'                    => '#383838',
                        'link_color'                    => '#4365e0',
                        'btn_primary_color'             => '#fff',
                        'btn_primary_bg'                => '#4365e0',
                        'btn_cart_color'                => '#fff',
                        'btn_cart_bg'                   => '#4365e0',
                        'btn_wishlist_color'            => '#383838',
                        'btn_wishlist_bg'               => '#fff',
                        'btn_compare_color'             => '#383838',
                        'btn_compare_bg'                => '#fff',

                        // Templates
                        'template_category'             => '1',
                        'template_category_specific_1'  => '',
                        'template_category_specific_2'  => '',
                        'child_category_thumb'          => '1',
                        'grid_product_desc'             => '0',
                        'child_thumb_size_width'        => '700',
                        'child_thumb_size_height'       => '250',

                        'template_product'              => '1',
                        'template_product_specific_1'   => '',
                        'template_product_specific_2'   => '',
                        'related_product_desc'          => '0',

                        'template_contact'              => '1',
                        'contact_map'                   => '1',
                        'geocode'                       => '',
                        'template_404'                  => '2',
                        'product_module_desc'           => '0',

                        // Block Layouts
                        'position_top_a'                => '12',
                        'position_top_b'                => '6-3-3',
                        'position_top_c'                => '12',
                        'position_content_top_a'        => '12',
                        'position_content_top_b'        => '12',
                        'position_content_btm_a'        => '12',
                        'position_content_btm_b'        => '12',
                        'position_bottom_a'             => '12',
                        'position_bottom_b'             => '12',
                        'position_bottom_c'             => '12',
                        'position_footer_ribbon'        => '12',
                        'position_footer_a'             => '6-6',
                        'position_footer_b'             => '3-3-3-3',
                        'position_footer_c'             => '4-4-4',
                    );

                    $default2_setting   = $this->model_setting_setting->getSetting('default2', 0);
                    $presets            = $this->model_setting_setting->getSetting('default2_preset', 0);
                    $preset_store       = $this->model_setting_setting->getSetting('default2', $this->config->get('store_id'));
                    $default2_preset    = $default_preset;
                    if (!empty($preset_store)) {
                        $default2_preset   = isset($presets[$preset_store['preset_id']]) ? array_merge($default_preset, $presets[$preset_store['preset_id']]) : $default_preset;
                    }

                    $this->config->set('default2_version', isset($default2_setting['version']) ? $default2_setting['version'] : '1.0.0');
                    $this->config->set('default2', $default2_preset);
                }
            
		if ($this->config->get('config_maintenance')) {
			$route = '';

			if (isset($this->request->get['route'])) {
				$part = explode('/', $this->request->get['route']);

				if (isset($part[0])) {
					$route .= $part[0];
				}
			}

			// Show site if logged in as admin
			$this->user = new User($this->registry);

			if (($route != 'payment' && $route != 'api') && !$this->user->isLogged()) {
				return new Action('common/maintenance/info');
			}
		}
	}

	public function info() {
		$this->load->language('common/maintenance');

		$this->document->setTitle($this->language->get('heading_title'));

		if ($this->request->server['SERVER_PROTOCOL'] == 'HTTP/1.1') {
			$this->response->addHeader('HTTP/1.1 503 Service Unavailable');
		} else {
			$this->response->addHeader('HTTP/1.0 503 Service Unavailable');
		}

		$this->response->addHeader('Retry-After: 3600');

		$data['heading_title'] = $this->language->get('heading_title');

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_maintenance'),
			'href' => $this->url->link('common/maintenance')
		);

		$data['message'] = $this->language->get('text_message');

		$data['header'] = $this->load->controller('common/header');
		$data['footer'] = $this->load->controller('common/footer');

		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/common/maintenance.tpl')) {
			$this->response->setOutput($this->load->view($this->config->get('config_template') . '/template/common/maintenance.tpl', $data));
		} else {
			$this->response->setOutput($this->load->view('default/template/common/maintenance.tpl', $data));
		}
	}
}
