<?php
class ModelToolImage extends Model {

			public function resizeOcbwatermark($filename, $width, $height, $store_id) {
				if (!is_file(DIR_IMAGE . $filename)) {
					return;
				}
				
				$store_id = $this->config->get('config_store_id');
				
				$extension = pathinfo($filename, PATHINFO_EXTENSION);

				$old_image = $filename;
				$new_image = 'cache/' . $store_id . utf8_substr($filename, 0, utf8_strrpos($filename, '.')) . '-' . $width . 'x' . $height . '.' . $extension;

				if (!is_file(DIR_IMAGE . $new_image) || (filectime(DIR_IMAGE . $old_image) > filectime(DIR_IMAGE . $new_image))) {
					$path = '';

					$directories = explode('/', dirname(str_replace('../', '', $new_image)));
					
					foreach ($directories as $directory) {
						$path = $path . '/' . $directory;

						if (!is_dir(DIR_IMAGE . $path)) {
							@mkdir(DIR_IMAGE . $path, 0777);
						}
					}
					
					$image = new Image(DIR_IMAGE . $old_image);
					$image->resize($width, $height);
					
					$wnew_image = 'cache/' . $store_id . '-ocbwatermark-' . $width . 'x' . $height . '.png';

					$watermarksize = getimagesize(DIR_IMAGE . $this->config->get('config_watermark_image'));
					$ratio = $width/$watermarksize[0];
					
					if ($ratio > 0) {
						$watermark = new Image(DIR_IMAGE . $this->config->get('config_watermark_image'));
						$watermark->resize(round(($watermarksize[0]*$ratio/2),0), round(($watermarksize[1]*$ratio/2),0));
						$watermark->save(DIR_IMAGE . $wnew_image);
					} else 	{
						$wnew_image = $this->config->get('config_watermark_image');
					}
					
					
					$image->ocbwatermark(DIR_IMAGE . $wnew_image, $this->config->get('config_watermark_position'));
					$image->save(DIR_IMAGE . $new_image);
					
				}
					
				if ($this->request->server['HTTPS']) {
					return $this->config->get('config_ssl') . 'image/' . $new_image;
				} else {
					return $this->config->get('config_url') . 'image/' . $new_image;
				}
			}
			
	public function resize($filename, $width, $height) {
		if (!is_file(DIR_IMAGE . $filename)) {
			return;
		}

		$extension = pathinfo($filename, PATHINFO_EXTENSION);

		$old_image = $filename;
		$new_image = 'cache/' . utf8_substr($filename, 0, utf8_strrpos($filename, '.')) . '-' . $width . 'x' . $height . '.' . $extension;

		if (!is_file(DIR_IMAGE . $new_image) || (filectime(DIR_IMAGE . $old_image) > filectime(DIR_IMAGE . $new_image))) {
			$path = '';

			$directories = explode('/', dirname(str_replace('../', '', $new_image)));

			foreach ($directories as $directory) {
				$path = $path . '/' . $directory;

				if (!is_dir(DIR_IMAGE . $path)) {
					@mkdir(DIR_IMAGE . $path, 0777);
				}
			}

			list($width_orig, $height_orig) = getimagesize(DIR_IMAGE . $old_image);

			if ($width_orig != $width || $height_orig != $height) {
				$image = new Image(DIR_IMAGE . $old_image);
				$image->resize($width, $height);
				$image->save(DIR_IMAGE . $new_image);
			} else {
				copy(DIR_IMAGE . $old_image, DIR_IMAGE . $new_image);
			}
		}

		if ($this->request->server['HTTPS']) {
			return $this->config->get('config_ssl') . 'image/' . $new_image;
		} else {
			return $this->config->get('config_url') . 'image/' . $new_image;
		}
	}
}
